package com.zipcodewilmington.phone;

import com.zipcodewilmington.exceptions.InvalidPhoneNumberFormatException;

import java.util.Random;
import java.util.logging.Logger;

/**
 * Created by leon on 5/1/17.
 */
public final class PhoneNumberFactory {
    private static final Logger logger = Logger.getGlobal();

    private PhoneNumberFactory() {
        /** This constructor is private
         *  This class is uninstantiable */
    }

    /**
     * @param phoneNumberCount - number of PhoneNumber objects to instantiate
     * @return array of randomly generated PhoneNumber objects
     */ //TODO - Implement logic
    public static PhoneNumber[] createRandomPhoneNumberArray(int phoneNumberCount) throws InvalidPhoneNumberFormatException{

    PhoneNumber[]  phone=new PhoneNumber[phoneNumberCount];
    for(int i=0;i<phoneNumberCount;i++ )
    {
        phone[i]=createRandomPhoneNumber();
    }

        return phone;
    }
    /**
     * @return an instance of PhoneNumber with randomly generated phone number value
     */ //TODO - Implement logic
    public static PhoneNumber createRandomPhoneNumber()  {
        Random random=new Random();
        int areaCode=random.nextInt(900 ) +100;
        int centralOfficeCode=random.nextInt(900)+100;
        int phoneLineCode=random.nextInt(8990)+1000;
        System.out.println("areacode" +areaCode+"\tcentralOfficeCode:"+ centralOfficeCode +"\t phoneLineCode"+phoneLineCode);

        return createPhoneNumberSafely(areaCode , centralOfficeCode ,phoneLineCode );
    }


    /**
     * @param areaCode          - 3 digit code
     * @param centralOfficeCode - 3 digit code
     * @param phoneLineCode     - 4 digit code
     * @return a new phone number object
     */ //TODO - if input is valid, return respective PhoneNumber object, else return null
    public static PhoneNumber createPhoneNumberSafely(int areaCode, int centralOfficeCode, int phoneLineCode) {
        String phoneNumber="(" + areaCode + ")-" +centralOfficeCode +"-"+phoneLineCode;
        try {
            PhoneNumber phoneNumber1 = new PhoneNumber(phoneNumber);
            return phoneNumber1;

        } catch( InvalidPhoneNumberFormatException e)
         {
         logger.warning("invalid phone number" ) ;
         return  null;
    }
}

    /**
     * @param phoneNumberString - some String corresponding to a phone number whose format is `(###)-###-####`
     * @return a new phone number object
     * @throws InvalidPhoneNumberFormatException - thrown if phoneNumberString does not match acceptable format
     */ // TODO - Add throws statement to method signature
    public static PhoneNumber createPhoneNumber(String phoneNumberString) throws InvalidPhoneNumberFormatException {
        //phoneNumberString ="302-312-5555";
        PhoneNumber phone=new PhoneNumber(phoneNumberString );
        logger.info("Attempting to create a new PhoneNumber object with a value of " + phone);
        return   phone;
    }
}
